<?php

// Your username, password and customer number are imported from the following file    	
// CPCWS_Serviceinfo_PHP_Samples\REST\serviceinfo\user.ini
$userProperties = parse_ini_file(realpath(dirname($_SERVER['SCRIPT_FILENAME'])) . '/../user.ini');

$username = $userProperties['username']; 
$password = $userProperties['password'];


// REST URL
$service_url = 'https://ct.soa-gw.canadapost.ca/rs/serviceinfo/outlet';

$curl = curl_init($service_url); // Create REST Request
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2); 
curl_setopt($curl, CURLOPT_CAINFO, realpath(dirname($_SERVER['SCRIPT_FILENAME'])) . '/../../../third-party/cert/cacert.pem'); // Mozilla cacerts
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
curl_setopt($curl, CURLOPT_USERPWD, $username . ':' . $password);
curl_setopt($curl, CURLOPT_HTTPHEADER, array('Accept-Language:en-CA','Accept: application/vnd.cpc.serviceinfo-v2+xml'));
$curl_response = curl_exec($curl); // Execute REST Request
if(curl_errno($curl)){
	echo 'Curl error: ' . curl_error($curl) . "\n";
}

echo 'HTTP Response Status: ' . curl_getinfo($curl,CURLINFO_HTTP_CODE) . "\n";

curl_close($curl);

// Example of using SimpleXML to parse xml response
libxml_use_internal_errors(true);
$xml = simplexml_load_string('<root>' . preg_replace('/<\?xml.*\?>/','',$curl_response) . '</root>');
if (!$xml) {
	echo 'Failed loading XML' . "\n";
	echo $curl_response . "\n";
	foreach(libxml_get_errors() as $error) {
		echo "\t" . $error->message;
	}
} else {
	if ($xml->{'info-messages'} ) {
		$info_messages = $xml->{'info-messages'}->children('http://www.canadapost.ca/ws/serviceinfo-v2');
		foreach ($info_messages as $info_message){
			echo  "\n" . 'Message Text is :' . $info_message->{'message-text'} ."\n\n";
			echo  "\n" . 'Message Type is :' . $info_message->{'message-type'} ."\n\n";
			echo  "\n" . 'Message start time is :' . $info_message->{'from-datetime'} ."\n\n";
			echo  "\n" . 'Message end time is :' . $info_message->{'to-datetime'} ."\n\n";
		}
	}
	if ($xml->{'messages'} ) {					
		$messages = $xml->{'messages'}->children('http://www.canadapost.ca/ws/messages');		
		foreach ( $messages as $message ) {
			echo 'Error Code: ' . $message->code . "\n";
			echo 'Error Msg: ' . $message->description . "\n\n";
		}
	}
}

?>
